#INCLUDE "dcdialog.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "SqlQuery.CH"
#INCLUDE "web.CH"

#define MENU_BAR_BGCOLOR       GRA_CLR_BACKGROUND
#define MENU_BAR_FGCOLOR       GRA_CLR_BLACK
#define MENU_SUB_BGCOLOR       GraMakeRGBColor( {240,240,240} )
#define MENU_SUB_FGCOLOR       GRA_CLR_BLACK
#define MENU_SUB_BARCOLORFG    GraMakeRGBColor( {100,100,100} )
#define MENU_SUB_BARCOLORBG    GraMakeRGBColor( {240,240,240} )
#define MENU_SUB_OUTLINECOLOR  GraMakeRGBColor( {100,100,100} )
#define MENU_SUB_VERTBARFONT   '12.Arial Bold'
#define MENU_SUB_CHECKFONT     '10.Marlett'
#define MENU_SUB_CHECKCHAR     'b'
#define MENU_BAR_BARFONT       '8.Arial'
#define MENU_SUB_ITEMFONT      '8.Arial'

#DEFINE CRLF Chr(13)+Chr(10)
#xtranslate NTrim(<n>)   =>  LTrim(Str(<n>))

#define ERR_LOG_FILE      'ERROR.LOG'

STATIC soSqlQuery, slWebServerIsRunning := .f.

FUNCTION Main()

LOCAL oSqlQuery, cParam, i, cSqlTable, cISAMTable, nCachedColumns, cIniName, ;
      cGroupName, cSqlFile, cSqlScript, oThread, bExecute, oConnection, ;
      nThreads := 0, cProcedure, cCMDScript, cView, cSql, cISAMScript, ;
      lParams := .f., nPointer := 1, oBrowse, lStatus, GetList[0], ;
      lXpButtons := .t., oButtonConfig, aParams, cExportFile, ;
      nWebServerPort

DC_Sett('EDITOR','C:\public\q.bat')
DC_Sett('ODIR',DC_Path(AppName(.t.)))
DC_Sett('PDIR',DC_Path(AppName(.t.)))

DC_IconDefault(ICON_DICTIONARY)

aParams := { MENU_SUB_BGCOLOR, ;
             MENU_SUB_BARCOLORFG, ;
             MENU_SUB_BARCOLORBG, ;
             MENU_SUB_OUTLINECOLOR, ;
             MENU_SUB_VERTBARFONT, ;
             .F., ;
             MENU_SUB_CHECKFONT, ;
             MENU_SUB_CHECKCHAR, ;
             MENU_BAR_FGCOLOR, ;
             MENU_BAR_BGCOLOR, ;
             MENU_SUB_FGCOLOR, ;
             MENU_BAR_BARFONT, ;
             MENU_SUB_ITEMFONT }

DC_XbpMenuConfig(aParams)

DbSetNullValue(.f.)
SET NULLVALUE OFF

IF !Empty(PValue(1)) .AND. '.INI' $ Upper(PValue(1))
  cIniName := PValue(1)
ENDIF

FOR i := 1 TO PCount()
  cParam := PValue(i)
  IF !Empty(cParam)
    IF Left(cParam,1) = '/'
      lParams := .t.
    ENDIF
    IF Upper(cParam) = '/CC:'
      nCachedColumns := Val(SubStr(cParam,5))
    ELSEIF Upper(cParam) = '/EE:'
      cExportFile := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/WS:'
      nWebServerPort := Val(Substr(cParam,5))
    ELSEIF Upper(cParam) = '/SF:'
      cSQLFile := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/SQLFILE:'
      cSQLFile := Substr(cParam,10)
    ELSEIF Upper(cParam) = '/SS:'
      cSQLScript := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/SQLSCRIPT:'
      cSQLScript := Substr(cParam,12)
    ELSEIF Upper(cParam) = '/ST:'
      cSqlTable := 'SELECT * FROM ' + Substr(cParam,5)
    ELSEIF Upper(cParam) = '/SQLTABLE:'
      cSqlTable := 'SELECT * FROM ' + Substr(cParam,11)
    ELSEIF Upper(cParam) = '/SQ:'
      cSql := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/SQLSTATEMENT:'
      cSql := Substr(cParam,15)
    ELSEIF Upper(cParam) = '/SQL:'
      cSql := Substr(cParam,6)
    ELSEIF Upper(cParam) = '/CS:'
      cCMDScript := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/CMDSCRIPT:'
      cCMDScript := SubStr(cParam,12)
    ELSEIF Upper(cParam) = '/PR:'
      cProcedure := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/PROC:'
      cProcedure := Substr(cParam,7)
    ELSEIF Upper(cParam) = '/VW:'
      cView := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/VIEW:'
      cView := Substr(cParam,7)
    ELSEIF Upper(cParam) = '/IT:'
      cISAMTable := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/ISAMTABLE:'
      cISAMTable := Substr(cParam,12)
    ELSEIF Upper(cParam) = '/IS:'
      cISAMScript := Substr(cParam,5)
    ELSEIF Upper(cParam) = '/ISAMSCRIPT:'
      cISAMScript := Substr(cParam,13)
    ELSEIF Upper(cParam) = '/CO:'
      cGroupName := Upper(Substr(cParam,5))
    ELSEIF Upper(cParam) = '/CONN:'
      cGroupName := Upper(Substr(cParam,7))
    ELSEIF Upper(cParam) = '/NOXPBUTTONS'
      lXpButtons := .f.
    ELSEIF Upper(cParam) = '/NX'
      lXpButtons := .f.
    ELSEIF '/?' $ cParam .OR. '/H' $ Upper(cParam)
      SqlQueryCommandLineHelp()
      QUIT
    ELSEIF cParam = '/'
      DC_WinAlert('Unknown command line parameter: ' + cParam)
    ENDIF
  ENDIF
NEXT

DEFAULT cIniName := DC_Path(AppName(.t.))+'SqlQuery.Ini'

soSqlQuery := SqlQuery():new( cIniName )

IF !Empty(nCachedColumns)
  soSqlQuery:nCachedColumns := nCachedColumns
ENDIF

IF !Empty(nWebServerPort)
   // start up webserver

ELSEIF !Empty(cGroupName)

  oConnection := soSqlQuery:LoadSessions(cGroupName)
  IF Empty(oConnection)
    DCMSGBOX 'Group Name ' + cGroupName + ' does not exist in ' + cIniName ;
      FONT '10.Lucida Console'
    QUIT
  ENDIF
  IF !oConnection:connect()
    DCMSGBOX 'Connection failed to ' + cGroupName FONT '10.Lucida Console'
    QUIT
  ENDIF

ELSEIF lParams

  soSqlQuery:loadSessions()

  @ 0,0 DCSAY '/CONN:<cGroupName> is REQUIRED when using command line parameters.;;' + ;
              'The <GroupName> is declared in ' + cIniName + ';;' + ;
              'Example: SqlQuery /CONN:ADS_15' ;
               SAYSIZE 80,4 SAYWORDBREAK ;
               FONT '10.Lucida Console'

  @ 5,0 DCBROWSE oBrowse DATA soSqlQuery:sessionsArray SIZE 60,20 FIT ;
        FONT '10.Lucida Console' HEADLINES 2 ;
        POINTER nPointer ;
        ITEMSELECTED {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
        NOHSCROLL

  DCBROWSECOL OBJECTVAR 'GroupName' HEADER 'Group;Name' WIDTH 10 PARENT oBrowse
  DCBROWSECOL OBJECTVAR 'Name' HEADER 'Name' WIDTH 50 PARENT oBrowse

  DCREAD GUI FIT ADDBUTTONS TITLE 'Choose a Connection' MODAL TO lStatus ;
     NOAUTORESTORE

  IF lStatus
    cGroupName := sosqlQuery:sessionsArray[nPointer]:GroupName
    oConnection := soSqlQuery:loadSessions(cGroupName)
    IF !oConnection:connect()
      DCMSGBOX 'Connection failed to ' + cGroupName FONT '10.Lucida Console'
      QUIT
    ENDIF
  ELSE
    QUIT
  ENDIF

ENDIF

IF lXpButtons
  oButtonConfig := DC_XbpPushButtonXPDefault():new()
  oButtonConfig:mouseOverScale := 1.1
  oButtonConfig:mouseOverFont := '9.Helv Bold'
  oButtonConfig:fgColorMouse := GRA_CLR_BLACK
  oButtonConfig:gradientStep := 3
  oButtonConfig:bgColor := GRA_CLR_WHITE
  DC_PushButtonStyle( oButtonConfig )
  DC_ExpressButtonStyle( oButtonConfig )
  DC_PopupButtonStyle( oButtonConfig )
ENDIF

IF Empty(oConnection) .AND. Empty(nWebServerPort)
  soSqlQuery:LoadSessions()
  soSqlQuery:showDialog()
  RETURN nil
ELSE
  soSqlQuery:lShowWorkingMessage := .t.
ENDIF

DC_SetCpu()

IF !Empty(nWebServerPort) .AND. !slWebServerIsRunning
  bExecute := {||nThreads++,WebServer(nWebServerPort),slWebServerIsRunning := .f., dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cSqlScript) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:LoadScript(cSqlScript,oConnection,.t.),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cIsamScript) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:LoadScript(cIsamScript,oConnection,.t.),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cSqlTable) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:executeSql(cSqlTable,,oConnection,,1,,,,,,,,50,,cExportFile),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cSqlFile) .AND. oConnection:isConnected
  IF !Fexists(cSqlFile)
    DCMSGBOX 'SQL file ' + cSqlFile + ' cannot be opened' FONT '10.Lucida Console'
    QUIT
  ENDIF
  cSqlFile := MemoRead(cSqlFile)
  bExecute := {||nThreads++,soSqlQuery:executeSql(cSqlFile,,oConnection,,1,,,,,,,,50,,cExportFile),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cSql) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:executeSql(cSql,,oConnection,,1,,,,,,,,50,,cExportFile),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cProcedure) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:DictProcedureExecuteSQL( cProcedure, oConnection, 1, .t. ),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cView) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:ViewExecute( cView, oConnection, 1 ),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cCmdScript) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:CommandWindow( oConnection, cCmdScript, .t. ),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF !Empty(cIsamTable) .AND. oConnection:isConnected
  bExecute := {||nThreads++,soSqlQuery:BrowseISAM(cIsamTable,oConnection),dbCloseAll(),nThreads--}
  oThread := Thread():new()
  oThread:start(bExecute)
  Sleep(50)
ENDIF

IF nThreads > 0
  DC_ReadGuiHandler({|a,b,c,d,e,f,g|soSqlQuery:ReadGuiHandler(a,b,c,d,e,f,@g)})
ENDIF

Sleep(300)

DO WHILE nThreads > 0 .OR. Len(AppDeskTop():childList()) > 0
  Sleep(200)
ENDDO

RETURN nil

* ---------

PROC appsys ; RETURN

* ---------

FUNCTION WebServer( nPort )

LOCAL GetList[0], cPort, cHost, oHttpEndPoint, lStarted, oMle, cMemo := '', ;
      oStart, GetOptions

DEFAULT nPort := 8001

cPort := Alltrim(Str(nPort))

cHost := "http://" + GetEnv('Computername')

oHttpEndpoint := MyHttpEndpoint():new(nPort)
lStarted := oHttpEndpoint:start()

IF !lStarted
  DCMSGBOX 'Could not start server on port: ' + cPort
ENDIF

@ 0,0 DCSAY "SqlQuery Web service" FONT '12.Arial Bold'

@ 2,0 DCSAY 'Host: ' + cHost + ':' + cPort SAYSIZE 0 SAYBOTTOM ;
      FONT '12.Lucida Console Bold' COLOR GRA_CLR_BLUE

@ 4,0 DCPUSHBUTTON CAPTION {||IIF(lStarted,'STOP','START') + ' Http Server'} SIZE 30,1.5 ;
      FONT '10.Arial Bold' OBJECT oStart ;
      ACTION {||IIF( lStarted,oHttpEndPoint:stop(),oHttpEndPoint:start() ), ;
                lStarted := !lStarted, DC_GetRefresh(GetList)}

@ 7,0 DCMULTILINE cMemo OBJECT oMle SIZE 100,5 FONT '10.Lucida Console' NOHSCROLL ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCGETOPTIONS SAYWIDTH 0 RESIZE RESIZEDEFAULT DCGUI_RESIZE_REPOSONLY_Y

DCREAD GUI FIT TITLE 'SqlQuery HttpServer' OPTIONS GetOptions

oHttpEndPoint:stop()

RETURN nil


* ==============

CLASS MyHttpEndpoint FROM HttpEndpoint

EXPORTED:

METHOD defaultProcessors
METHOD start

ENDCLASS

METHOD MyHttpEndpoint:start()

RETURN SUPER:start()

* ---------

METHOD MyHttpEndpoint:defaultProcessors()

LOCAL aRet := SUPER:DefaultProcessors()
AAdd( aRet , "HtmlFileProcessor" )

RETURN(aRet)

* ------------

CLASS CustomWebHandler FROM WebHandler

EXPORTED:

INLINE METHOD GetVar( cVarName )
RETURN ::httpRequest:getForm():getVariable(cVarName)

INLINE METHOD SetErrorBlock()
ErrorBlock({|e|LogError(e)})
RETURN self

// Dispatch the request to existing methods. Return a generic
// web page for all other requests.
//
INLINE METHOD Execute( cMethodName )

LOCAL cResponse := ""

::setErrorBlock()

IF IsMethod(SELF, cMethodName)
  RETURN SUPER:execute( cMethodName )
ENDIF

cResponse += "<!DOCTYPE html>"
cResponse += "<html>"
cResponse +=   "<head><title>Unhandled request</title></head>"
cResponse +=   "<body>"
cResponse +=     "<h1>No handler for: "+cMethodName+"</h1>"
cResponse +=     "<small>Sorry</small>"
cResponse +=   "</body>"
cResponse += "<html>"

RETURN cResponse

ENDCLASS

* --------------

CLASS Test FROM CustomWebHandler

  EXPORTED:
    METHOD echo, getTime, echoVars, crash

ENDCLASS

* --------

METHOD Test:echoVars()

LOCAL cResponse, aVars, i, oForm

::setErrorBlock()
BEGIN SEQUENCE

oForm := ::httpRequest:getForm()
aVars := oForm:getCollection()
cResponse := '<H1> Echoing all Vars </H1>'
cResponse += '<pre>' + CRLF

FOR i := 1 TO Len(aVars)
  cResponse += aVars[i,1] + ' : ' + aVars[i,2] + CRLF
NEXT

cResponse += '</pre>'

RECOVER USING cResponse
END SEQUENCE

RETURN cResponse

* ------------

METHOD Test:echo( cParamName1 )

LOCAL cHtml := ""

::setErrorBlock()

cHtml += "<html><title>Donnay:echo() was called</title><body>"
cHtml += '<pre>'
cHtml += "Parameter cParamName1 is " + cParamName1 + CRLF
cHtml += 'Pcount is: ' + Alltrim(Str(Pcount())) + CRLF
cHtml += 'Query String is: ' + ::httpRequest:getQueryString() + CRLF
cHtml += "</pre></body></html>"

RETURN cHtml

//
// The method :get() handles the RESTful path CurrentTime/get
//
METHOD Test:getTime()

LOCAL cThreadId
LOCAL cResponse := ""

cThreadId := AllTrim(Str(ThreadId()))

::setErrorBlock()

BEGIN SEQUENCE

cResponse += "<!DOCTYPE html>"
cResponse += "<html>"
cResponse +=   "<head><title>"+ProcName()+"</title></head>"
cResponse +=   "<body>"
cResponse +=     "<h1>Current Time:</h1>"
cResponse +=     "<p>"+Time()+" (HH:MM:SS)</p>"
cResponse +=     "<small>By thread: "+cThreadId+"</small>"
cResponse +=   "</body>"
cResponse += "</html>"

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse

* -----------

METHOD Test:crash()

LOCAL cResponse

::setErrorBlock()

BEGIN SEQUENCE

&('CrashThisProgram()')

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse


* =====================

CLASS SqlService FROM CustomWebHandler

  EXPORTED:
    METHOD Query

ENDCLASS

* ----------

METHOD SqlService:query( cSql )

LOCAL cParams, cHtml

cParams := '/co:ADS_1 /sq:"' + cSql + '" /ee:reply.htm'

// ::httpResponse:contentType := 'text/html'
// ::httpResponse:writeStr( 'Please wait while executing your query...' )
// ::httpResponse:send()

Runshell(cParams,'sqlquery.exe')

IF File('reply.htm')
  cHtml := MemoRead('reply.htm')
ELSE
  cHtml := 'Cannot run your query'
ENDIF

RETURN cHtml

* -------------

STATIC FUNCTION LogError( oError )

LOCAL cError, i, cProcName

cError := "= Donnay Software Web Server Error ==========" + CRLF +;
             "Date: " + DTOS(Date()) + ", Time: " + Time() + CRLF +;
             "App: " + AppName(.t.) + ", Thread: " + LTrim(Str(ThreadID())) + CRLF

// error generated while processing http server request
cError += if(oError:severity > ES_WARNING, "ERROR ", "WARNING " ) +;
          if(ValType(oError:subSystem)   == "C", oError:subSystem, "???" ) + "/" +;
          if(ValType(oError:subCode)     == "N", NTrim(oError:subCode), "???" ) + CRLF +;
          if(ValType(oError:cargo)       == "C", oError:cargo + CRLF, "" ) +;
          if(ValType(oError:description) == "C", oError:description, "" )

// add either filename or operation
if !Empty(oError:filename)
   cError += ": " + oError:filename
elseif !Empty(oError:operation)
   cError += ": " + oError:operation
endif

if !Empty( oError:osCode )
   cError += CRLF + "(OS Error: " + NTrim(oError:osCode) + ")"
endif

for i := 2 to 12
   if Empty(cProcName := ProcName(i))
      exit
   endif
   cError += CRLF+"Called from "+cProcName+"("+LTrim(Str(ProcLine(i)))+")"
next

SaveToFile( cError + CRLF, ERR_LOG_FILE )

cError := '<pre>' + cError + '</pre>'

Break( cError )

RETURN ''

* -----------

STATIC FUNCTION SaveToFile( cText, cFileName )

Local i := 0, nHandle

if ValType(cText) != "C" .or. Empty(cText)
   Return .f.
endif

if FExists(cFileName)
   while (nHandle := FOpen(cFileName, FO_WRITE + FO_DENYWRITE)) < 0
      if ++i > 9
         Return .f.
      endif
      Sleep(20)
   end
   FSeek(nHandle, 0, FS_END)  // position to end of file
else
   while (nHandle := FCreate(cFileName)) < 0
      if ++i > 9
         Return .f.
      endif
      Sleep(20)
   end
endif

FWrite(nHandle, cText + CRLF)
FClose(nHandle)

Return .t.


